# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ContainerRegistry::Mgmt::V2018_02_01_preview
  module Models
    #
    # The parameters for updating a build task.
    #
    class BuildTaskUpdateParameters

      include MsRestAzure

      # @return [String] The alternative updatable name for a build task.
      attr_accessor :alias_property

      # @return [BuildTaskStatus] The current status of build task. Possible
      # values include: 'Disabled', 'Enabled'
      attr_accessor :status

      # @return [PlatformProperties] The platform properties against which the
      # build has to happen.
      attr_accessor :platform

      # @return [Integer] Build timeout in seconds.
      attr_accessor :timeout

      # @return [SourceRepositoryUpdateParameters] The properties that
      # describes the source(code) for the build task.
      attr_accessor :source_repository

      # @return [Hash{String => String}] The ARM resource tags.
      attr_accessor :tags


      #
      # Mapper for BuildTaskUpdateParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'BuildTaskUpdateParameters',
          type: {
            name: 'Composite',
            class_name: 'BuildTaskUpdateParameters',
            model_properties: {
              alias_property: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.alias',
                type: {
                  name: 'String'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.status',
                type: {
                  name: 'String'
                }
              },
              platform: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.platform',
                type: {
                  name: 'Composite',
                  class_name: 'PlatformProperties'
                }
              },
              timeout: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.timeout',
                constraints: {
                  InclusiveMaximum: 28800,
                  InclusiveMinimum: 300
                },
                type: {
                  name: 'Number'
                }
              },
              source_repository: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.sourceRepository',
                type: {
                  name: 'Composite',
                  class_name: 'SourceRepositoryUpdateParameters'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
