# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ContainerRegistry::Mgmt::V2019_06_01_preview
  module Models
    #
    # The request parameters for scheduling a run.
    #
    class RunRequest

      include MsRestAzure

      @@discriminatorMap = Hash.new
      @@discriminatorMap["DockerBuildRequest"] = "DockerBuildRequest"
      @@discriminatorMap["FileTaskRunRequest"] = "FileTaskRunRequest"
      @@discriminatorMap["TaskRunRequest"] = "TaskRunRequest"
      @@discriminatorMap["EncodedTaskRunRequest"] = "EncodedTaskRunRequest"

      def initialize
        @type = "RunRequest"
      end

      attr_accessor :type

      # @return [Boolean] The value that indicates whether archiving is enabled
      # for the run or not. Default value: false .
      attr_accessor :is_archive_enabled

      # @return [String] The dedicated agent pool for the run.
      attr_accessor :agent_pool_name

      # @return [String] The template that describes the repository and tag
      # information for run log artifact.
      attr_accessor :log_template


      #
      # Mapper for RunRequest class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RunRequest',
          type: {
            name: 'Composite',
            polymorphic_discriminator: 'type',
            uber_parent: 'RunRequest',
            class_name: 'RunRequest',
            model_properties: {
              is_archive_enabled: {
                client_side_validation: true,
                required: false,
                serialized_name: 'isArchiveEnabled',
                default_value: false,
                type: {
                  name: 'Boolean'
                }
              },
              agent_pool_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'agentPoolName',
                type: {
                  name: 'String'
                }
              },
              log_template: {
                client_side_validation: true,
                required: false,
                serialized_name: 'logTemplate',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
